package KITExcellence;
import java.io.IOException;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Graphics;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

public class EliteSolutionsMIDLet extends MIDlet implements CommandListener {

	private GameEngine engine;
	private SpriteManager manager;
	private Display    display;
	private MyViewB	   viewB;
	private Command	   exit;
	private Command	   pause;
	private Command	   resume;
	
	public EliteSolutionsMIDLet() throws IOException {
		this.display = Display.getDisplay(this);
		
		MyModel model = new MyModel(10, 100, 50, 50, 50);
		this.engine = new GameEngine(model, 50);
		manager = new SpriteManager(engine.getTimer());
		try {
			this.viewB = new MyViewB(model, "tux");
			this.engine.attach(viewB);
		} catch(Exception e) {
			System.out.println("Exception: " + e.getMessage());
			e.printStackTrace();
		}
		
		Displayable drawingArea = this.engine.getDrawingArea(); 
			
		drawingArea.setCommandListener(this);
		
		this.resume = new Command("Resume", Command.SCREEN, 2);
		drawingArea.addCommand(this.resume);

		this.pause = new Command("Pause", Command.SCREEN, 1);
		drawingArea.addCommand(this.pause);
		
		this.exit = new Command("Exit", Command.EXIT, 1);
		drawingArea.addCommand(this.exit);
	}
	
	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#startApp()
	 */
	protected void startApp() throws MIDletStateChangeException {
		this.display.setCurrent(this.engine.getDrawingArea());
		System.err.println("startApp called");		
		this.engine.start();
	}
	
	/* (non-Javadoc)
	 * @see javax.microedition.lcdui.CommandListener#commandAction(javax.microedition.lcdui.Command, javax.microedition.lcdui.Displayable)
	 */
	public void commandAction(Command c, Displayable d) {
		if (c == this.exit) {
			System.err.println("Exit...");
			try {
				destroyApp(true);
			} catch (MIDletStateChangeException e) {
				return;
			}
			notifyDestroyed();
		} else
		if (c == this.resume) {
			this.engine.resume();
		} else
		if (c == this.pause) {
			this.engine.pause();
		}
	}
	
	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#destroyApp(boolean)
	 */
	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		System.err.println("destroyApp called");
	}

	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#pauseApp()
	 */
	protected void pauseApp() {
		System.err.println("pauseApp called");
	}
	
	private class MyViewB implements GameView {

		private MyModel model;
		private Sprite  sprite;
		
		public MyViewB(MyModel model, String spriteName) throws IOException {
			this.model = model;
			sprite = manager.createSprite(spriteName);
		}
		
		public void render(Graphics g) {
			sprite.draw(g, (int) model.x, (int) model.y);
		}
	}
	
	private class MyModel implements GameModel {

		private float speedx;
		private float speedy;
		
		float x, y;
		int w, h;
		
		public MyModel(int x, int y, int w, int h, int speed) {
			this.x = x;
			this.y = y;
			this.w = w;
			this.h = h;
			
			this.speedx = speed;
			this.speedy = 0;
		}
		
		public void update(int keys, int width, int height, float time_delta) {
			if (x <= 0 || x  + w >= width) {
				speedx *= -1;
			}
			
			if (y <= 0 || y + h >= height) {
				speedy *= -1;
			}
			
			x += speedx * time_delta;
			y += speedy * time_delta;
		}
	}
}
