package KITExcellence;

import javax.microedition.lcdui.Graphics;

import KITExcellence.SpriteData.Action;

public class Sprite {
	private GameTimer timer;
	private SpriteData data;
	private Action currentAction;
	private float last_ticks;
	private float frame;
	private float speed = 1.0f;
	
	protected Sprite(SpriteData data, GameTimer timer) {
		this.timer = timer;
		this.data = data;
		last_ticks = timer.get();
		currentAction = data.getDefaultAction();
	}
	
	public void setAction(String name) {
		currentAction = data.getAction(name);
	}
	
	private void update() {
		float speed     = this.speed * currentAction.getFps();
		float frame_inc = speed * (timer.get() - last_ticks);
		last_ticks = timer.get();
		
		frame += frame_inc;
		if (frame >= currentAction.getFrameCount()) {
			frame = frame_inc % currentAction.getFrameCount();
		}
	}
	
	public void draw(Graphics g, int x, int y) {
		update();
		currentAction.drawFrame(g, x, y, (int) frame);
	}
}
