package KITExcellence;

import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;
import java.util.Vector;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

public class SpriteData {
	private Hashtable actions = new Hashtable();
	
	private static class Frame {
		public Image image;
		/* TODO: other stuff */
	}
	
	public Action getDefaultAction() {
		return (Action) actions.elements().nextElement();
	}
	
	public Action getAction(String name) {
		Action action = (Action) actions.get(name);
		if (action == null)
			throw new RuntimeException("Action " + name + " not found");
		return action;
	}
	
	protected static class Action {
		
		public Action(String name) {
			this.name = name;
			this.fps  = 10;
		}
		
		public void addFrame(Image image) {
			Frame frame = new Frame();
			frame.image = image;
			frames.addElement(frame);
		}
		
		public void addFrame(String imageName) throws IOException {
			InputStream input = Action.class.getResourceAsStream(imageName);
			if (input == null) {
				throw new IOException("File " + input + " not found");
			}
			Image image = Image.createImage(input);
			addFrame(image);
		}
		
		public String getName() {
			return name;
		}
		
		public int getFrameCount() {
			return frames.size();
		}
		
		public float getFps() {
			return fps;
		}
		
		public void drawFrame(Graphics g, int x, int y, int num) {
			Frame frame = (Frame) frames.elementAt(num);
			g.drawImage(frame.image, x, y, Graphics.TOP | Graphics.LEFT);
		}
		
		private String name;
		private Vector frames = new Vector();
		private float fps;
	}

	public void testCreateTux() throws IOException {
		/* testdata */
		Action walkright = new Action("walk-right");
		String base = "/tux/";
		walkright.addFrame(base + "largetux-walk-right-0.png");
		walkright.addFrame(base + "largetux-walk-right-1.png");
		walkright.addFrame(base + "largetux-walk-right-2.png");
		walkright.addFrame(base + "largetux-walk-right-3.png");
		walkright.addFrame(base + "largetux-walk-right-4.png");
		walkright.addFrame(base + "largetux-walk-right-5.png");
		actions.put(walkright.getName(), walkright);		
	}
	
	public void testCreateSnowball() throws IOException {
		Action roll = new Action("roll");
		String base = "/snowball/";
		roll.addFrame(base + "left-0.png");
		roll.addFrame(base + "left-1.png");
		roll.addFrame(base + "left-2.png");
		roll.addFrame(base + "left-3.png");
		roll.addFrame(base + "left-4.png");
		roll.addFrame(base + "left-5.png");
		actions.put(roll.getName(), roll);
	}
}
